﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace tesztverseny
{
    class Versenyzo
    {
        public string Kod { get; set; }
        public string Valasz { get; set; }
        public int Hossz { get; set; }
        public int Pont { get; set; }
        public Versenyzo(string[] adat)
        {
            Kod = adat[0];
            Valasz = adat[1];
            Hossz = Valasz.Length;
            Pont = -1;
        }
        public string Check(string helyes)
        {
            string s = "";
            for (int i = 0; i < Hossz; i++)
            {
                s += Valasz[i] == helyes[i] ? '+' : ' ';
            }
            return s;
        }
        public int Eredmeny(string helyes, int[] pontok)
        {
            int p = 0;
            for (int i = 0; i < Hossz; i++)
            {
                p += Valasz[i] == helyes[i] ? pontok[i] : 0;
            }
            return p;
        }
    }
    class Program
    {
        static List<Versenyzo> verseny = new List<Versenyzo>();
        static int[] pontok = { 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 6 };
        static string helyes = "";

        static void Main(string[] args)
        {
            Console.WriteLine("1. feladat: Az adatok beolvasása");
            F1_Input();
            Console.WriteLine("2. feladat: A vetélkedőn {0} versenyző indult.", verseny.Count);
            Console.Write("3. feladat: A versenyző azonosítója = ");
            string kod = Console.ReadLine();
            int ez = F3_Find(kod);
            Console.WriteLine(verseny[ez].Valasz);
            Console.WriteLine("4. feladat:");
            Console.WriteLine(helyes);
            Console.WriteLine(verseny[ez].Check(helyes));
            Console.Write("5. feladat: A feladat sorszáma = ");
            int sorszam = int.Parse(Console.ReadLine())-1;
            int db = F5_Count(sorszam);
            Console.WriteLine("A feladatra {0} fő, a versenyzők {1:P2}-a adott helyes választ.",db, db*1.0/verseny.Count);
            Console.WriteLine("6. feladat: A versenyzők pontszámának meghatározása");
            F6_Output();
            Console.WriteLine("7. feladat: A verseny legjobbjai:");
            F7_Best();

            Console.ReadLine();
        }

        static void F1_Input()
        {
            using (System.IO.StreamReader sr = new System.IO.StreamReader("valaszok.txt"))
            {
                helyes = sr.ReadLine();
                while (!sr.EndOfStream)
                {
                    verseny.Add(new Versenyzo(sr.ReadLine().Split(' ')));
                }
            }
        }

        static int F3_Find(string kod)
        {
            int ez = 0;
            while (verseny[ez].Kod != kod) ez++;
            return ez;
        }

        static int F5_Count(int ssz)
        {
            int db = 0;
            for (int i = 0; i < verseny.Count; i++)
            {
                if (verseny[i].Valasz[ssz]==helyes[ssz])
                {
                    db++;
                }
            }
            return db;
        }

        static void F6_Output()
        {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("pontok.txt"))
            {
                for (int i = 0; i < verseny.Count; i++)
                {
                    verseny[i].Pont = verseny[i].Eredmeny(helyes, pontok);
                    sw.WriteLine("{0} {1}", verseny[i].Kod, verseny[i].Pont);
                }
            }
        }

        static void F7_Best()
        {
            int maxpont = 0;
            for (int i = 0; i < 14; i++)
            {
                maxpont += pontok[i];
            }
            int[] gyakorisag = new int[maxpont + 1];
            for (int i = 0; i < verseny.Count; i++)
            {
                gyakorisag[verseny[i].Pont]++;
            }

            int hely = 1;
            int pont = maxpont;
            
            while (hely<4 & pont>0)
            {
                while (pont>0 & gyakorisag[pont] == 0)
                {
                    pont--;
                }
                int db = 0;
                for (int i = 0; i < verseny.Count && db<gyakorisag[pont]; i++)
                {
                    if (verseny[i].Pont == pont)
                    {
                        Console.WriteLine("{0}. díj ({1} pont): {2}",hely, pont, verseny[i].Kod);
                        db++;
                    }
                }
                hely++;
                pont--;
            }
        }
        
    }
}
